aboutsummaryrefslogtreecommitdiff
path: root/scripts/install-nix-from-closure.sh
diff options
context:
space:
mode:
authorDomen Kožar <domen@dev.si>2020-10-20 12:18:23 +0200
committerGitHub <noreply@github.com>2020-10-20 12:18:23 +0200
commite0ca98c2071b815578470e280df8fdb750c7e23b (patch)
tree413beb5a783b8ca9d2611cafd369611e116f7fe9 /scripts/install-nix-from-closure.sh
parent9635fb77bd63ac736a28d5500bc1ecfa555e6fb5 (diff)
parentf289bdb9d4e8432160c5dcdc037a930b2025d11b (diff)
Merge pull request #3996 from abathur/macos_big_sur_fixes
Macos big sur installer fixes
Diffstat (limited to 'scripts/install-nix-from-closure.sh')
-rw-r--r--scripts/install-nix-from-closure.sh23
1 files changed, 17 insertions, 6 deletions
diff --git a/scripts/install-nix-from-closure.sh b/scripts/install-nix-from-closure.sh
index 14fb91534..2de41a6a4 100644
--- a/scripts/install-nix-from-closure.sh
+++ b/scripts/install-nix-from-closure.sh
@@ -26,9 +26,20 @@ fi
# macOS support for 10.12.6 or higher
if [ "$(uname -s)" = "Darwin" ]; then
- macos_major=$(sw_vers -productVersion | cut -d '.' -f 2)
- macos_minor=$(sw_vers -productVersion | cut -d '.' -f 3)
- if [ "$macos_major" -lt 12 ] || { [ "$macos_major" -eq 12 ] && [ "$macos_minor" -lt 6 ]; }; then
+ IFS='.' read macos_major macos_minor macos_patch << EOF
+$(sw_vers -productVersion)
+EOF
+ # TODO: this is a temporary speed-bump to keep people from naively installing Nix
+ # on macOS Big Sur (11.0+, 10.16+) until nixpkgs updates are ready for them.
+ # *Ideally* this is gone before next Nix release. If you're intentionally working on
+ # Nix + Big Sur, just comment out this block and be on your way :)
+ if [ "$macos_major" -gt 10 ] || { [ "$macos_major" -eq 10 ] && [ "$macos_minor" -gt 15 ]; }; then
+ echo "$0: nixpkgs isn't quite ready to support macOS $(sw_vers -productVersion) yet"
+ exit 1
+ fi
+
+ if [ "$macos_major" -lt 10 ] || { [ "$macos_major" -eq 10 ] && [ "$macos_minor" -lt 12 ]; } || { [ "$macos_minor" -eq 12 ] && [ "$macos_patch" -lt 6 ]; }; then
+ # patch may not be present; command substitution for simplicity
echo "$0: macOS $(sw_vers -productVersion) is not supported, upgrade to 10.12.6 or higher"
exit 1
fi
@@ -90,7 +101,7 @@ while [ $# -gt 0 ]; do
) >&2
# darwin and Catalina+
- if [ "$(uname -s)" = "Darwin" ] && [ "$macos_major" -gt 14 ]; then
+ if [ "$(uname -s)" = "Darwin" ] && { [ "$macos_major" -gt 10 ] || { [ "$macos_major" -eq 10 ] && [ "$macos_minor" -gt 14 ]; }; }; then
(
echo " --darwin-use-unencrypted-nix-store-volume: Create an APFS volume for the Nix"
echo " store and mount it at /nix. This is the recommended way to create"
@@ -110,8 +121,8 @@ if [ "$(uname -s)" = "Darwin" ]; then
"$self/create-darwin-volume.sh"
fi
- info=$(diskutil info -plist / | xpath "/plist/dict/key[text()='Writable']/following-sibling::true[1]" 2> /dev/null)
- if ! [ -e $dest ] && [ -n "$info" ] && [ "$macos_major" -gt 14 ]; then
+ writable="$(diskutil info -plist / | xmllint --xpath "name(/plist/dict/key[text()='Writable']/following-sibling::*[1])" -)"
+ if ! [ -e $dest ] && [ "$writable" = "false" ]; then
(
echo ""
echo "Installing on macOS >=10.15 requires relocating the store to an apfs volume."